varying vec3 normal;
varying vec4 position;

void main()
{	
  vec3 norm = normalize(normal);
  // Light vector
  vec3 lightv = normalize( gl_LightSource[0].position.xyz - position.xyz);
  vec3 viewv = -normalize(position.xyz);
  vec3 halfv = normalize(lightv + viewv);
  float nl = dot (norm, viewv);
  if (nl < 0.0)
    norm *= -1.0;
  /* diffuse reflection */
  vec4 diffuse = max(0.0, nl)
    *gl_FrontMaterial.diffuse*gl_LightSource[0].diffuse;
  /* ambient reflection */
  vec4 ambient = gl_FrontMaterial.ambient*gl_LightSource[0].ambient;

  /* specular reflection */
  vec4 specular = vec4(0.0, 0.0, 0.0, 1.0);
  if( dot(lightv, viewv) > 0.0) {
    specular = pow(max(0.0, dot(norm, halfv)),
		   gl_FrontMaterial.shininess) * gl_FrontMaterial.specular*gl_LightSource[0].specular;
  }
  vec3 color = clamp( vec3(ambient + diffuse + specular), 0.0, 1.0);

  gl_FragColor =  vec4(color, 1.0);
}

